Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.event
Interface Receiver

All Superinterfaces:
  Result

All Known Implementing Classes:
  AllElementValidator, AnyTypeValidator, AssertionTreeBuilder, AttributeValidator, Base64BinaryEmitter, BinaryEmitter, BinaryTextDecoder, Builder, BuilderMonitor, CDATAFilter, CharacterMapExpander, Checker, CommentStripper, ComplexContentOutputter, ComplexContentValidator, ConstraintChecker, ContentHandlerProxy, ContentValidator, DocumentValidator, DOM4JWriter, DOMWriter, Emitter, EmptyContentValidator, EntityValidator, EvaluationNuisance, FieldChecker, HexBinaryEmitter, HTMLEmitter, HTMLIndenter, HTMLIndenterPE, HTMLURIEscaper, IDFilter, IdValidator, IgnorableWhitespaceStripper, ImplicitResultChecker, JDOMWriter, LaxValidator, LinkedBuilderMonitor, LinkedTreeBuilder, MessageEmitter, MessageWarner, MetaTagAdjuster, NamePoolConverter, NamespaceReducer, PathMaintainer, PIGrabber, Projector, ProxyReceiver, PTreeEmitter, SchemaModelLoader, SequenceExchanger.SequencePusher, SequenceFilter, SequenceOutputter, SequenceReceiver, SequenceTransmitter, SequenceWrapper, SequenceWriter, SimpleContentValidator, Sink, SkipValidator, StartTagBuffer, StartTagBufferEE, StringValueAccumulator, Stripper, StylesheetPackager.ImportIncludeFilter, TeeOutputter, TEXTEmitter, TinyBuilder, TinyBuilderCondensed, TinyBuilderMonitor, TracingFilter, TransformerReceiver, TreeReceiver, TypeCheckingFilter, TypedContentHandler, UncommittedSerializer, UnicodeNormalizer, UseWhenFilter, ValidatingFilter, ValidationStack, VersionControlFilter, WatchManager, XHTMLEmitter, XHTMLURIEscaper, XML10ContentChecker, XMLEmitter, XMLIndenter, XMLIndenterPE, XOMWriter, XQueryEmitter, XSIAttributeHandler

    public interface Receiver

extends Result

Receiver: This interface represents a recipient of XML tree-walking (push) events. It is based on SAX2's ContentHandler, but adapted to handle additional events, and to use Saxon's name pool. Namespaces and Attributes are handled by separate events following the startElement event. Schema types can be defined for elements and attributes.

The Receiver interface is an important internal interface within Saxon, and provides a powerful mechanism for integrating Saxon with other applications. It has been designed with extensibility and stability in mind. However, it should be considered as an interface designed primarily for internal use, and not as a completely stable part of the public Saxon API.

Author:
  Michael H. Kay

Field Summary

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Method Summary
`void` | `attribute(NodeName attName, SimpleType typeCode, CharSequence value, int locationId, int properties)` Notify an attribute.
`void` | `characters(CharSequence chars, int locationId, int properties)` Notify character data.
`void` | `close()` Notify the end of the event stream
`void` | `comment(CharSequence content, int locationId, int properties)` Notify a comment.
`void` | `endDocument()` Notify the end of a document node
`void` | `endElement()` Notify the end of an element.
`PipelineConfiguration` | `getPipelineConfiguration()` Get the pipeline configuration
`void` | `namespace(NamespaceBinding namespaceBinding, int properties)` Notify a namespace.
`void` | `open()` Notify the start of the event stream
`void` | `processingInstruction(String name, CharSequence data, int locationId, int properties)` Output a processing instruction
`void` | `setPipelineConfiguration(PipelineConfiguration pipe)` Set the pipeline configuration
`void` | `setSystemId(String systemId)` Set the System ID of the tree represented by this event stream
`void` | `setUnparsedEntity(String name, String systemID, String publicID)` Notify an unparsed entity URI.
`void` | `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` | `startDocument(int properties)` Notify the start of a document node
`void` | `startElement(NodeName elemName, SchemaType typeCode, int locationId, int properties)` Notify the start of an element
`boolean` | `usesTypeAnnotations()` Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

Methods inherited from interface javax.xml.transform.Result
`getSystemId`

Method Detail

### setPipelineConfiguration

    void setPipelineConfiguration(PipelineConfiguration pipe)

  Set the pipeline configuration

  Parameters:
    `pipe` - the pipeline configuration

### getPipelineConfiguration

    PipelineConfiguration getPipelineConfiguration()

  Get the pipeline configuration

  Returns:
    the pipeline configuration

### setSystemId

    void setSystemId(String systemId)

  Set the System ID of the tree represented by this event stream

  Specified by:
    `setSystemId` in interface `Result`
  Parameters:
    `systemId` - the system ID (which is used as the base URI of the nodes if there is no xml:base attribute)

### open

    void open()
              throws XPathException

  Notify the start of the event stream

  Throws:
    `XPathException` - if an error occurs

### startDocument

    void startDocument(int properties)
                       throws XPathException

  Notify the start of a document node

  Parameters:
    `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### endDocument

    void endDocument()
                     throws XPathException

  Notify the end of a document node

  Throws:
    `XPathException` - if an error occurs

### setUnparsedEntity

    void setUnparsedEntity(String name,
                           String systemID,
                           String publicID)
                           throws XPathException

  Notify an unparsed entity URI.

  Parameters:
    `name` - The name of the unparsed entity
    `systemID` - The system identifier of the unparsed entity
    `publicID` - The public identifier of the unparsed entity
  Throws:
    `XPathException` - if an error occurs

### startElement

    void startElement(NodeName elemName,
                      SchemaType typeCode,
                      int locationId,
                      int properties)
                      throws XPathException

  Notify the start of an element

  Parameters:
    `elemName` - the name of the element.
    `typeCode` - the type annotation of the element.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - bit-significant properties of the element node. If there are no revelant properties, zero is supplied. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### namespace

    void namespace(NamespaceBinding namespaceBinding,
                   int properties)
                   throws XPathException

  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element. The events represent namespace declarations and undeclarations rather than in-scope namespace nodes: an undeclaration is represented by a namespace code of zero. If the sequence of namespace events contains two A namespace must not conflict with any namespaces already used for element or attribute names.

  Parameters:
    `namespaceBinding` - contains the namespace prefix and namespace URI
    `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error:
  Throws:
    `XPathException` - if an error occurs

### attribute

    void attribute(NodeName attName,
                   SimpleType typeCode,
                   CharSequence value,
                   int locationId,
                   int properties)
                   throws XPathException

  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Parameters:
    `attName` - The name of the attribute
    `typeCode` - The type of the attribute, as held in the name pool. The additional bit NodeInfo.IS_DTD_TYPE may be set to indicate a DTD-derived type.
    `value` - the string value of the attribute
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this attribute
  NO_SPECIAL_CHARACTERS
    Attribute value contains no special characters
  Throws:
    `IllegalStateException:` - attempt to output an attribute when there is no open element start tag
    `XPathException` - if an error occurs

### startContent

    void startContent()
                      throws XPathException

  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

  Throws:
    `XPathException` - if an error occurs

### endElement

    void endElement()
                    throws XPathException

  Notify the end of an element. The receiver must maintain a stack if it needs to know which element is ending.

  Throws:
    `XPathException` - if an error occurs

### characters

    void characters(CharSequence chars,
                    int locationId,
                    int properties)
                    throws XPathException

  Notify character data. Note that some receivers may require the character data to be sent in a single event, but in general this is not a requirement.

  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  Throws:
    `XPathException` - if an error occurs

### processingInstruction

    void processingInstruction(String name,
                               CharSequence data,
                               int locationId,
                               int properties)
                               throws XPathException

  Output a processing instruction

  Parameters:
    `name` - The PI name. This must be a legal name (it will not be checked).
    `data` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI.
  Throws:
    `IllegalArgumentException:` - the content is invalid for an XML processing instruction
    `XPathException` - if an error occurs

### comment

    void comment(CharSequence content,
                 int locationId,
                 int properties)
                 throws XPathException

  Notify a comment. Comments are only notified if they are outside the DTD.

  Parameters:
    `content` - The content of the comment
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment.
  Throws:
    `IllegalArgumentException:` - the content is invalid for an XML comment
    `XPathException` - if an error occurs

### close

    void close()
               throws XPathException

  Notify the end of the event stream

  Throws:
    `XPathException` - if an error occurs

### usesTypeAnnotations

    boolean usesTypeAnnotations()

  Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

  Returns:
    true if the Receiver makes any use of this information. If false, the caller may supply untyped nodes instead of supplying the type annotation (or conversely, it may avoid stripping unwanted type annotations)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.